searchNodes=[{"doc":"","ref":"Astarte.Core.html","title":"Astarte.Core","type":"module"},{"doc":"","ref":"Astarte.Core.html#defs/0","title":"Astarte.Core.defs/0","type":"function"},{"doc":"This module contains a set of functions that should be used to map Astarte types and concepts to C*","ref":"Astarte.Core.CQLUtils.html","title":"Astarte.Core.CQLUtils","type":"module"},{"doc":"returns an endpoint UUID for a certain endpoint on a certain interface_name with a certain interface_major.","ref":"Astarte.Core.CQLUtils.html#endpoint_id/3","title":"Astarte.Core.CQLUtils.endpoint_id/3","type":"function"},{"doc":"Returns the column name for a certain endpoint that will be used for object interface tables.","ref":"Astarte.Core.CQLUtils.html#endpoint_to_db_column_name/1","title":"Astarte.Core.CQLUtils.endpoint_to_db_column_name/1","type":"function"},{"doc":"Returns the CQL query statement that should be used to retrieve interface descriptor from the database.","ref":"Astarte.Core.CQLUtils.html#interface_descriptor_statement/0","title":"Astarte.Core.CQLUtils.interface_descriptor_statement/0","type":"function"},{"doc":"Returns interface UUID for a certain interface_name with a certain interface_major","ref":"Astarte.Core.CQLUtils.html#interface_id/2","title":"Astarte.Core.CQLUtils.interface_id/2","type":"function"},{"doc":"Returns a generated table name that might be used during table creation.&quot;","ref":"Astarte.Core.CQLUtils.html#interface_name_to_table_name/2","title":"Astarte.Core.CQLUtils.interface_name_to_table_name/2","type":"function"},{"doc":"Returns true if a given CQL name can be safely used for a table or a column name","ref":"Astarte.Core.CQLUtils.html#is_valid_cql_name?/1","title":"Astarte.Core.CQLUtils.is_valid_cql_name?/1","type":"function"},{"doc":"Returns a CQL type for a given mapping value type atom","ref":"Astarte.Core.CQLUtils.html#mapping_value_type_to_db_type/1","title":"Astarte.Core.CQLUtils.mapping_value_type_to_db_type/1","type":"function"},{"doc":"Returns table column name that stores a certain type.","ref":"Astarte.Core.CQLUtils.html#type_to_db_column_name/1","title":"Astarte.Core.CQLUtils.type_to_db_column_name/1","type":"function"},{"doc":"Utility functions to deal with Astarte devices","ref":"Astarte.Core.Device.html","title":"Astarte.Core.Device","type":"module"},{"doc":"Decodes a Base64 url encoded device id and returns it as a 128-bit binary (usable as uuid).By default, it will fail with {:error, :extended_id_not_allowed} if the size of the encoded device_id is &gt; 128 bit. You can pass allow_extended_id: true as second argument to allow longer device ids (the returned binary will still be 128 bit long, but the function will not return an error and will instead drop the extended id).Returns {:ok, device_id} or {:error, reason}.","ref":"Astarte.Core.Device.html#decode_device_id/2","title":"Astarte.Core.Device.decode_device_id/2","type":"function"},{"doc":"Decodes an extended Base64 url encoded device id.Returns {:ok, device_id, extended_id} (where device_id is a binary with the first 128 bits of the decoded id and extended_id the rest of the decoded binary) or {:error, reason}.","ref":"Astarte.Core.Device.html#decode_extended_device_id/1","title":"Astarte.Core.Device.decode_extended_device_id/1","type":"function"},{"doc":"Encodes a device id with the standard encoding (Base64 url encoding, no padding). The device id must be exactly 16 bytes (128 bits) long.Returns the encoded device id.","ref":"Astarte.Core.Device.html#encode_device_id/1","title":"Astarte.Core.Device.encode_device_id/1","type":"function"},{"doc":"Generate a random Astarte device id.The generated device id is also a valid UUID v4.","ref":"Astarte.Core.Device.html#random_device_id/0","title":"Astarte.Core.Device.random_device_id/0","type":"function"},{"doc":"","ref":"Astarte.Core.Device.html#t:device_id/0","title":"Astarte.Core.Device.device_id/0","type":"type"},{"doc":"","ref":"Astarte.Core.Device.html#t:encoded_device_id/0","title":"Astarte.Core.Device.encoded_device_id/0","type":"type"},{"doc":"Functions that deal with Astarte groups","ref":"Astarte.Core.Group.html","title":"Astarte.Core.Group","type":"module"},{"doc":"Returns true if group_name is a valid group name, false otherwise.Valid group names do not start with reserved characters @ and ~.","ref":"Astarte.Core.Group.html#valid_name?/1","title":"Astarte.Core.Group.valid_name?/1","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.html","title":"Astarte.Core.Interface","type":"module"},{"doc":"","ref":"Astarte.Core.Interface.html#changeset/2","title":"Astarte.Core.Interface.changeset/2","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.html#interface_name_regex/0","title":"Astarte.Core.Interface.interface_name_regex/0","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Aggregation.html","title":"Astarte.Core.Interface.Aggregation","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.Interface.Aggregation.html#embed_as/1","title":"Astarte.Core.Interface.Aggregation.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.Interface.Aggregation.html#equal?/2","title":"Astarte.Core.Interface.Aggregation.equal?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Aggregation.html#from_int/1","title":"Astarte.Core.Interface.Aggregation.from_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Aggregation.html#to_int/1","title":"Astarte.Core.Interface.Aggregation.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Ownership.html","title":"Astarte.Core.Interface.Ownership","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.Interface.Ownership.html#embed_as/1","title":"Astarte.Core.Interface.Ownership.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.Interface.Ownership.html#equal?/2","title":"Astarte.Core.Interface.Ownership.equal?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Ownership.html#from_int/1","title":"Astarte.Core.Interface.Ownership.from_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Ownership.html#to_int/1","title":"Astarte.Core.Interface.Ownership.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Type.html","title":"Astarte.Core.Interface.Type","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.Interface.Type.html#embed_as/1","title":"Astarte.Core.Interface.Type.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.Interface.Type.html#equal?/2","title":"Astarte.Core.Interface.Type.equal?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Type.html#from_int/1","title":"Astarte.Core.Interface.Type.from_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Interface.Type.html#to_int/1","title":"Astarte.Core.Interface.Type.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.InterfaceDescriptor.html","title":"Astarte.Core.InterfaceDescriptor","type":"module"},{"doc":"Deserializes an %InterfaceDescriptor{} from db_result. db_result can be a keyword list or a map.Returns the {:ok, %InterfaceDescriptor{}} on success, {:error, :invalid_interface_descriptor_data} on failure.","ref":"Astarte.Core.InterfaceDescriptor.html#from_db_result/1","title":"Astarte.Core.InterfaceDescriptor.from_db_result/1","type":"function"},{"doc":"Deserializes an %InterfaceDescriptor{} from db_result. db_result can be a keyword list or a map.Returns the %InterfaceDescriptor{} on success, raises on failure","ref":"Astarte.Core.InterfaceDescriptor.html#from_db_result!/1","title":"Astarte.Core.InterfaceDescriptor.from_db_result!/1","type":"function"},{"doc":"Builds an %InterfaceDescriptor{} starting from an %Interface{}Returns the %InterfaceDescriptor{}","ref":"Astarte.Core.InterfaceDescriptor.html#from_interface/1","title":"Astarte.Core.InterfaceDescriptor.from_interface/1","type":"function"},{"doc":"This module handles Interface Mappings using Ecto Changesets","ref":"Astarte.Core.Mapping.html","title":"Astarte.Core.Mapping","type":"module"},{"doc":"","ref":"Astarte.Core.Mapping.html#changeset/3","title":"Astarte.Core.Mapping.changeset/3","type":"function"},{"doc":"Deserializes a %Mapping{} from db_result. db_result can be a keyword list or a map.Returns the %Mapping{} on success, raises on failure","ref":"Astarte.Core.Mapping.html#from_db_result!/1","title":"Astarte.Core.Mapping.from_db_result!/1","type":"function"},{"doc":"Check if token is a placeholder.","ref":"Astarte.Core.Mapping.html#is_placeholder?/1","title":"Astarte.Core.Mapping.is_placeholder?/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.html#mapping_regex/0","title":"Astarte.Core.Mapping.mapping_regex/0","type":"function"},{"doc":"Removes all placeholders from an endpoint.","ref":"Astarte.Core.Mapping.html#normalize_endpoint/1","title":"Astarte.Core.Mapping.normalize_endpoint/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.DatabaseRetentionPolicy.html","title":"Astarte.Core.Mapping.DatabaseRetentionPolicy","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.Mapping.DatabaseRetentionPolicy.html#embed_as/1","title":"Astarte.Core.Mapping.DatabaseRetentionPolicy.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.Mapping.DatabaseRetentionPolicy.html#equal?/2","title":"Astarte.Core.Mapping.DatabaseRetentionPolicy.equal?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.DatabaseRetentionPolicy.html#from_int/1","title":"Astarte.Core.Mapping.DatabaseRetentionPolicy.from_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.DatabaseRetentionPolicy.html#to_int/1","title":"Astarte.Core.Mapping.DatabaseRetentionPolicy.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.EndpointsAutomaton.html","title":"Astarte.Core.Mapping.EndpointsAutomaton","type":"module"},{"doc":"builds the automaton for given mappings, returns :ok followed by the automaton tuple if build succeeded, otherwise :error and the reason.","ref":"Astarte.Core.Mapping.EndpointsAutomaton.html#build/1","title":"Astarte.Core.Mapping.EndpointsAutomaton.build/1","type":"function"},{"doc":"returns true if nfa is valid for given mappings","ref":"Astarte.Core.Mapping.EndpointsAutomaton.html#is_valid?/2","title":"Astarte.Core.Mapping.EndpointsAutomaton.is_valid?/2","type":"function"},{"doc":"returns a list of likely invalid endpoints for a certain list of mappings.","ref":"Astarte.Core.Mapping.EndpointsAutomaton.html#lint/1","title":"Astarte.Core.Mapping.EndpointsAutomaton.lint/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.EndpointsAutomaton.html#parse_endpoint/2","title":"Astarte.Core.Mapping.EndpointsAutomaton.parse_endpoint/2","type":"function"},{"doc":"returns :ok and an endpoint for a given path using a previously built automata ({transitions, accepting_states}). if path is not complete one or more endpoints will be guessed and :guessed followed by a list of endpoints is returned.","ref":"Astarte.Core.Mapping.EndpointsAutomaton.html#resolve_path/2","title":"Astarte.Core.Mapping.EndpointsAutomaton.resolve_path/2","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.Reliability.html","title":"Astarte.Core.Mapping.Reliability","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.Mapping.Reliability.html#embed_as/1","title":"Astarte.Core.Mapping.Reliability.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.Mapping.Reliability.html#equal?/2","title":"Astarte.Core.Mapping.Reliability.equal?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.Reliability.html#from_int/1","title":"Astarte.Core.Mapping.Reliability.from_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.Reliability.html#to_int/1","title":"Astarte.Core.Mapping.Reliability.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.Retention.html","title":"Astarte.Core.Mapping.Retention","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.Mapping.Retention.html#embed_as/1","title":"Astarte.Core.Mapping.Retention.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.Mapping.Retention.html#equal?/2","title":"Astarte.Core.Mapping.Retention.equal?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.Retention.html#from_int/1","title":"Astarte.Core.Mapping.Retention.from_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.Retention.html#to_int/1","title":"Astarte.Core.Mapping.Retention.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.ValueType.html","title":"Astarte.Core.Mapping.ValueType","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.Mapping.ValueType.html#embed_as/1","title":"Astarte.Core.Mapping.ValueType.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.Mapping.ValueType.html#equal?/2","title":"Astarte.Core.Mapping.ValueType.equal?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.ValueType.html#from_int/1","title":"Astarte.Core.Mapping.ValueType.from_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.ValueType.html#to_int/1","title":"Astarte.Core.Mapping.ValueType.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Mapping.ValueType.html#validate_value/2","title":"Astarte.Core.Mapping.ValueType.validate_value/2","type":"function"},{"doc":"Functions that deal with Astarte realms","ref":"Astarte.Core.Realm.html","title":"Astarte.Core.Realm","type":"module"},{"doc":"Returns true if realm_name is a valid realm name, false otherwise.Valid realm names match this regular expression: ~r/^[a-z][a-z0-9]{0,47}$/. In addition, the astarte and system names and the system_ prefix are reserved.","ref":"Astarte.Core.Realm.html#valid_name?/1","title":"Astarte.Core.Realm.valid_name?/1","type":"function"},{"doc":"","ref":"Astarte.Core.StorageType.html","title":"Astarte.Core.StorageType","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Astarte.Core.StorageType.html#embed_as/1","title":"Astarte.Core.StorageType.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Astarte.Core.StorageType.html#equal?/2","title":"Astarte.Core.StorageType.equal?/2","type":"function"},{"doc":"returns storage_type atom from a valid storage type int value.","ref":"Astarte.Core.StorageType.html#from_int/1","title":"Astarte.Core.StorageType.from_int/1","type":"function"},{"doc":"returns storage_type associated int value.","ref":"Astarte.Core.StorageType.html#to_int/1","title":"Astarte.Core.StorageType.to_int/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.html","title":"Astarte.Core.Triggers","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.html#defs/0","title":"Astarte.Core.Triggers.defs/0","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.DataTrigger.html","title":"Astarte.Core.Triggers.DataTrigger","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.DataTrigger.html#are_congruent?/2","title":"Astarte.Core.Triggers.DataTrigger.are_congruent?/2","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.html","title":"Astarte.Core.Triggers.SimpleEvents","type":"module"},{"doc":"Utility macro, use Astarte.Core.Triggers.SimpleEvents injects aliases for all the structs defined in the Astarte.Core.Triggers.SimpleEvents namespace","ref":"Astarte.Core.Triggers.SimpleEvents.html#__using__/1","title":"Astarte.Core.Triggers.SimpleEvents.__using__/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.html#defs/0","title":"Astarte.Core.Triggers.SimpleEvents.defs/0","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.Encoder.html","title":"Astarte.Core.Triggers.SimpleEvents.Encoder","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.Encoder.html#extract_bson_value/1","title":"Astarte.Core.Triggers.SimpleEvents.Encoder.extract_bson_value/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#device_connected_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.device_connected_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#device_disconnected_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.device_disconnected_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#device_error_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.device_error_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#incoming_data_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.incoming_data_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#incoming_introspection_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.incoming_introspection_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#interface_added_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.interface_added_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#interface_minor_updated_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.interface_minor_updated_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#interface_removed_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.interface_removed_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#path_created_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.path_created_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#path_removed_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.path_removed_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#value_change_applied_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.value_change_applied_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#value_change_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.value_change_event/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.html#value_stored_event/1","title":"Astarte.Core.Triggers.SimpleEvents.SimpleEvent.OneOf.Event.value_stored_event/1","type":"macro"},{"doc":"This module handles the functions for creating a SimpleTriggerConfig and converting it to and from a TaggedSimpleTrigger.","ref":"Astarte.Core.Triggers.SimpleTriggerConfig.html","title":"Astarte.Core.Triggers.SimpleTriggerConfig","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggerConfig.html#from_tagged_simple_trigger/1","title":"Astarte.Core.Triggers.SimpleTriggerConfig.from_tagged_simple_trigger/1","type":"function"},{"doc":"Creates a TaggedSimpleTrigger from a SimpleTriggerConfig.It is assumed that the SimpleTriggerConfig is valid and constructed using SimpleTriggerConfig.changesetReturns a %TaggedSimpleTrigger{}","ref":"Astarte.Core.Triggers.SimpleTriggerConfig.html#to_tagged_simple_trigger/1","title":"Astarte.Core.Triggers.SimpleTriggerConfig.to_tagged_simple_trigger/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.html","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf","type":"module"},{"doc":"Utility macro, use Astarte.Core.Triggers.SimpleTriggersProtobuf injects aliases for all the structs defined in the Astarte.Core.Triggers.SimpleTriggersProtobuf namespace","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.html#__using__/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.__using__/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.html#defs/0","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.defs/0","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger.html","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger.html#data_trigger/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger.data_trigger/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger.html#device_trigger/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger.device_trigger/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger.html#introspection_trigger/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.SimpleTriggerContainer.OneOf.SimpleTrigger.introspection_trigger/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.TriggerTargetContainer.OneOf.TriggerTarget.html","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.TriggerTargetContainer.OneOf.TriggerTarget","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.TriggerTargetContainer.OneOf.TriggerTarget.html#amqp_trigger_target/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.TriggerTargetContainer.OneOf.TriggerTarget.amqp_trigger_target/1","type":"macro"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils","type":"module"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#any_device_object_id/0","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.any_device_object_id/0","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#any_interface_object_id/0","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.any_interface_object_id/0","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#deserialize_simple_trigger/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.deserialize_simple_trigger/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#deserialize_trigger_target/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.deserialize_trigger_target/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#get_device_and_any_interface_object_id/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.get_device_and_any_interface_object_id/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#get_device_and_interface_object_id/2","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.get_device_and_interface_object_id/2","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#get_group_and_any_interface_object_id/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.get_group_and_any_interface_object_id/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#get_group_and_interface_object_id/2","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.get_group_and_interface_object_id/2","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#get_group_object_id/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.get_group_object_id/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#get_interface_id_or_any/2","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.get_interface_id_or_any/2","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#object_type_to_int!/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.object_type_to_int!/1","type":"function"},{"doc":"","ref":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.html#simple_trigger_to_data_trigger/1","title":"Astarte.Core.Triggers.SimpleTriggersProtobuf.Utils.simple_trigger_to_data_trigger/1","type":"function"}]